/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../../gcc/gcc/config/msp430/msp430.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../../gcc/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../../gcc/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../../gcc/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../../gcc/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../../gcc/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../../gcc/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../../gcc/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../../gcc/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../../gcc/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../../gcc/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../../gcc/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../../gcc/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../../gcc/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../../gcc/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../../gcc/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../../gcc/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../../gcc/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../../gcc/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../../gcc/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../../gcc/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../../gcc/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 31 "../../../gcc/gcc/config/msp430/constraints.md"
(IN_RANGE (ival, 1, 19)));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 36 "../../../gcc/gcc/config/msp430/constraints.md"
(IN_RANGE (ival, HOST_WIDE_INT_M1U << 20, 1 << 19)));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 42 "../../../gcc/gcc/config/msp430/constraints.md"
(IN_RANGE (ival, 1, 4)));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 47 "../../../gcc/gcc/config/msp430/constraints.md"
(IN_RANGE (ival, 0, 255)));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 52 "../../../gcc/gcc/config/msp430/constraints.md"
(IN_RANGE (ival, 256, 65535)));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 57 "../../../gcc/gcc/config/msp430/constraints.md"
(IN_RANGE (ival, 1, 16)));
}
static inline bool
satisfies_constraint_Ya (rtx op)
{
  return (GET_CODE (op) == MEM) && ((GET_CODE (XEXP (op, 0)) == REG) || (((GET_CODE (XEXP (op, 0)) == PLUS) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG) && ((
#line 68 "../../../gcc/gcc/config/msp430/constraints.md"
(CONST_INT_P (XEXP (XEXP (op, 0), 1)))) && (
#line 69 "../../../gcc/gcc/config/msp430/constraints.md"
(IN_RANGE (INTVAL (XEXP (XEXP (op, 0), 1)), HOST_WIDE_INT_M1U << 15, (1 << 15)-1)))))) || ((
#line 70 "../../../gcc/gcc/config/msp430/constraints.md"
(CONSTANT_P (XEXP (op, 0)))) || (GET_CODE (XEXP (op, 0)) == POST_INC))));
}
static inline bool
satisfies_constraint_Yl (rtx op)
{
  return (GET_CODE (op) == MEM) && (GET_CODE (XEXP (op, 0)) == LABEL_REF);
}
static inline bool
satisfies_constraint_Ys (rtx op)
{
  return (GET_CODE (op) == MEM) && ((!(
#line 89 "../../../gcc/gcc/config/msp430/constraints.md"
(TARGET_USE_430X_FOR_MEM))) && (((GET_CODE (XEXP (op, 0)) == PLUS) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG) && ((
#line 93 "../../../gcc/gcc/config/msp430/constraints.md"
(CONST_INT_P (XEXP (XEXP (op, 0), 1)))) && (
#line 94 "../../../gcc/gcc/config/msp430/constraints.md"
(IN_RANGE (INTVAL (XEXP (XEXP (op, 0), 1)), HOST_WIDE_INT_M1U << 15, (1 << 15)-1)))))) || ((GET_CODE (XEXP (op, 0)) == REG) || (GET_CODE (XEXP (op, 0)) == POST_INC))));
}
static inline bool
satisfies_constraint_Yc (rtx op)
{
  return (GET_CODE (op) == MEM) && ((GET_CODE (XEXP (op, 0)) == MEM) && (!(((GET_CODE (XEXP (XEXP (op, 0), 0)) == PLUS) && ((GET_CODE (XEXP (XEXP (XEXP (op, 0), 0), 0)) == REG) && (
#line 106 "../../../gcc/gcc/config/msp430/constraints.md"
(REGNO (XEXP (XEXP (op, 0), 0)) != SP_REGNO)))) || ((GET_CODE (XEXP (op, 0)) == REG) && (
#line 108 "../../../gcc/gcc/config/msp430/constraints.md"
(REGNO (XEXP (XEXP (op, 0), 0)) != SP_REGNO))))));
}
#endif /* tm-constrs.h */
